// MVSTracker.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "MVSTracker.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMVSTrackerApp

BEGIN_MESSAGE_MAP(CMVSTrackerApp, CWinApp)
	//{{AFX_MSG_MAP(CMVSTrackerApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_OPTIONS_AZERTYKEYBOARD, OnOptionsAzertykeyboard)
	ON_COMMAND(ID_OPTIONS_QWERTYKEYBOARD, OnOptionsQwertykeyboard)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMVSTrackerApp construction

CMVSTrackerApp::CMVSTrackerApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CMVSTrackerApp object

CMVSTrackerApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CMVSTrackerApp initialization

BOOL CMVSTrackerApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	SetRegistryKey(_T("NeoGeoDev"));

	CMainFrame* pFrame = new CMainFrame;
	m_pMainWnd = pFrame;

	// create and load the frame with its resources
	pFrame->LoadFrame(IDR_MAINFRAME,
		WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE, NULL,
		NULL);


   pFrame->SetIcon(LoadIcon(IDR_MAINFRAME), true);
   pFrame->SetIcon(LoadIcon(IDR_MAINFRAME), false);
	pFrame->ShowWindow(SW_SHOW);
	pFrame->UpdateWindow();

   InitialiseGlobals();
   pFrame->InitialiseToolBars();
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMVSTrackerApp message handlers





/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CMVSTrackerApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CMVSTrackerApp message handlers


void CMVSTrackerApp::OnOptionsAzertykeyboard() 
{
   // draw tick here, remove any tick from other entry and set global variable
   CMenu* pMenu = m_pMainWnd->GetMenu();

   pMenu->CheckMenuItem(ID_OPTIONS_QWERTYKEYBOARD, MF_UNCHECKED | MF_BYCOMMAND);
   pMenu->CheckMenuItem(ID_OPTIONS_AZERTYKEYBOARD, MF_CHECKED | MF_BYCOMMAND);

   WriteProfileInt("Options", "Keyboard", 0);
   Global::bQwertyLayout = false;
}

void CMVSTrackerApp::OnOptionsQwertykeyboard() 
{
   // draw tick here, remove any tick from other entry and set global variable
   CMenu* pMenu = m_pMainWnd->GetMenu();

   pMenu->CheckMenuItem(ID_OPTIONS_QWERTYKEYBOARD, MF_CHECKED | MF_BYCOMMAND);
   pMenu->CheckMenuItem(ID_OPTIONS_AZERTYKEYBOARD, MF_UNCHECKED | MF_BYCOMMAND);

   WriteProfileInt("Options", "Keyboard", 1);
   Global::bQwertyLayout = true;
}



void CMVSTrackerApp::InitialiseGlobals()
{
   // Give different names to voices on start up
   for (int i = 1; i < MAX_VOICES; i++)
   {
      CString VName;
      VName.Format("%02d Unnamed", i);
      Global::VoiceArray[i].SetName(VName);
   }

   for (i = 0; i < MAX_CHANNELS; i++)
      Global::bChannelActive[i] = true;

   // clear the clipboard pattern
   for (int c=0; c < MAX_CHANNELS; c++)
   {
      for (int r=0; r<PATSIZE; r++)
      {
         Global::Clipboard[c][r].Note = NOTE_BLANK;
         Global::Clipboard[c][r].Oct = -1;
         Global::Clipboard[c][r].Voice = -1;
         Global::Clipboard[c][r].Effect = -1;
         Global::Clipboard[c][r].Value = -1;
      }
   }

   // read in registry options
   Global::bQwertyLayout = (GetProfileInt("Options", "Keyboard", 1) != 0);
   if (Global::bQwertyLayout)
      OnOptionsQwertykeyboard();
   else
      OnOptionsAzertykeyboard();
}



