// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__D53BB5A2_6B05_4683_A354_EA0B66F2ABDD__INCLUDED_)
#define AFX_MAINFRM_H__D53BB5A2_6B05_4683_A354_EA0B66F2ABDD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ChildView.h"

class CMainFrame : public CFrameWnd
{
	
public:
	CMainFrame();
protected: 
	DECLARE_DYNAMIC(CMainFrame)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CChildView  m_wndView;
   CDialogBar  m_wndPatEdToolBar;
   CDialogBar  m_wndPatListToolBar;

   // used for toolbar
   CBitmap     m_bmpPlay;
   CBitmap     m_bmpStop;
   CBitmap     m_bmpPlayAll;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSetFocus(CWnd *pOldWnd);
	afx_msg void OnViewInstrEdit();
	afx_msg void OnPlPatNew();
	afx_msg void OnPhButEdit();
	afx_msg void OnPlPatDown();
	afx_msg void OnPlPatUp();
	afx_msg void OnPlPatRename();
	afx_msg void OnPlSongNew();
	afx_msg void OnPlSongInsert();
	afx_msg void OnPlSongUpdate();
	afx_msg void OnPlSongDelete();
	afx_msg void OnSelchangePlList();
	afx_msg void OnEditCopypattern();
	afx_msg void OnEditCopytrack();
	afx_msg void OnEditCuttrack();
	afx_msg void OnEditPastepattern();
	afx_msg void OnEditPastetrack();
	afx_msg void OnViewRommaker();
	afx_msg void OnViewMDRommaker();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

   void RenumberSongList();
   void CopyTrack(int PatNum, int ChanNum, int ClipChan);
   void PasteTrack(int PatNum, int ChanNum, int ClipChan);

   // Toolbar helper functions
public:
   void NewPattern() { OnPlPatNew(); }
   void ToolBar_SetOctave(int Value);
   int ToolBar_GetOctave();
   void ToolBar_SetCurrentVoice(int Value);
   int ToolBar_GetCurrentVoice();
   void InitialiseToolBars();
   void ToolBar_FillCombo();
   int ToolBar_GetPattern();
   int ToolBar_GetSongLen();
   int ToolBar_GetSongPattern(int Pos);
   void ToolBar_AddSongPattern(int PatNum);
   void ToolBar_ClearSongPatterns();
   void ToolBar_RefreshPatName();
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__D53BB5A2_6B05_4683_A354_EA0B66F2ABDD__INCLUDED_)
