// ******************************************************************
//
// Pattern handler class
//
// ******************************************************************

#pragma once

#include "constants.h"

typedef struct tagPatRow
{
   char Note;
   char Oct;
   char Voice;
   char Effect;
   char Value;
} PATROW;

typedef PATROW PATCHANNEL[64];


class CPattern
{
public:
   void Clear();
   char GetNote(int ChanNum, int Row) { return mChannels[ChanNum][Row].Note; }
   char GetOct(int ChanNum, int Row) { return mChannels[ChanNum][Row].Oct; }
   char GetVoice(int ChanNum, int Row) { return mChannels[ChanNum][Row].Voice; }
   char GetEffect(int ChanNum, int Row) { return mChannels[ChanNum][Row].Effect; }
   char GetValue(int ChanNum, int Row) { return mChannels[ChanNum][Row].Value; }
   void SetNote(int ChanNum, int Row, char Value) { mChannels[ChanNum][Row].Note = Value; }
   void SetOct(int ChanNum, int Row, char Value) { mChannels[ChanNum][Row].Oct = Value; }
   void SetVoice(int ChanNum, int Row, char Value) { mChannels[ChanNum][Row].Voice = Value; }
   void SetEffect(int ChanNum, int Row, char Value) { mChannels[ChanNum][Row].Effect = Value; }
   void SetValue(int ChanNum, int Row, char Value) { mChannels[ChanNum][Row].Value = Value; }

   CString GetPatternName() { return mPatternName; }
   void SetPatternName(CString Name) { mPatternName = Name; }

   unsigned char * BuildPattern(bool bUseActiveChannels = true);
   void SetPattern(unsigned char * pNewPat);

   int GetHighestInstrNo();

private:
   CString mPatternName;

   PATCHANNEL mChannels[MAX_CHANNELS];

   unsigned char mBuiltPattern[BUILTPATSIZE];
};

