// ******************************************************************
//
// V1 ROM Helper - Encodes 18500Hz, Mono, PCM WAV files to MVS ADPCM
//
// ******************************************************************

#pragma once

#include "constants.h"


class CSampleEncoding
{
public:
   bool ValidateFile(CString PathName, CString Filename);
   int GetModuleSize();

   bool Encode(CFile * fWrite);
   CString GetFilename() { return m_FileName; }

private:
   int limit(int InVal, int MAX, int MIN);
   short ADPCMDecode(BYTE code);
   BYTE ADPCMEncode(short samp);

   CString m_PathName;
   CString m_FileName;

   int m_WavLen;
   int m_ADPCMLen;

   // used for ADPCM encoding
   short m_Last;
   short m_Index;
};


