// ******************************************************************
//
// Constants
//
// ******************************************************************

#pragma once

const int MAX_CHANNELS = 4;
const int MAX_VOICES = 32;

const int MAXITEMS = 5; // note, oct, voice, effect value

const int LOWER_OCT_RANGE = 1;
const int UPPER_OCT_RANGE = 7;

const int NOTE_BLANK = 12;
const int NOTE_END = 13;

const int PATSIZE = 64;
const int MAX_PATTERNS = 64;
const int MAX_SONG_LEN = 64;

const int BUILTPATSIZE = 1024;

const int INSTRLEN = 25;


const int SIZE_SAMPLETABLE = 256; // WORDs
const int BYTESIZE_SAMPLETABLE = SIZE_SAMPLETABLE * 2;
const int FIRST_SAMPLE = 4;


static const char szInstrHeader[] = "MVSI1";
static const char szInstrLoadFilter[] = "Supported Instrument Files|*.ins;*.y12|Instrument Files (*.ins)|*.ins|Y12 Gens Kmod dump (*.y12)|*.y12||";
static const char szInstrFilter[] = "Instrument Files (*.ins)|*.ins||";
static const char szMusicHeader[] = "MVSM1";
static const char szMusicFilter[] = "Music Files (*.mus)|*.mus||";
static const char szTestROMFilter[] = "Test ROM files (*.bin)|*.bin||";
static const char szMVS0ROMFilter[] = "MVS0 binary (*.bin)|*.bin||";
static const char szROMFilter[] = "ROM files (*.bin)|*.bin||";
static const char szMODFilter[] = "MOD Files (*.mod)|*.mod||";
static const char szHeaderFileFilter[] = "C Header Files (*.h)|*.h||";

static const char szMODHeader[] = "M.K."; // offset 1080

static const char szQwertyLayout[] = "ZSXDCVGBHNJM ";
static const char szAzertyLayout[] = "WSXDCVGBHNJ, ";

// MOD file import
const unsigned short MOD_Periods[]={
	1712,1616,1524,1440,1356,1280,1208,1140,1076,1016,960,907,856, // oct 3
   808,762,720,678,640,604,570,538,508,480,453,428,               // oct 4
   404,381,360,339,320,302,285,269,254,240,226,214,               // oct 5
   202,190,180,170,160,151,143,135,127,120,113,107,               // oct 6
   101,95,90,85,80,75,71,67,63,60,56                              // oct 7
};                           
	

const unsigned short MOD_Notes[] = {
   0,1,2,3,4,5,6,7,8,9,10,11,
   0,1,2,3,4,5,6,7,8,9,10,11,
   0,1,2,3,4,5,6,7,8,9,10,11,
   0,1,2,3,4,5,6,7,8,9,10,11,
   0,1,2,3,4,5,6,7,8,9,10,11
};

const unsigned short MOD_Octaves[] = {
   3,3,3,3,3,3,3,3,3,3,3,3,
   4,4,4,4,4,4,4,4,4,4,4,4,
   5,5,5,5,5,5,5,5,5,5,5,5,
   6,6,6,6,6,6,6,6,6,6,6,6,
   7,7,7,7,7,7,7,7,7,7,7,7
};


const int MOD_SONG_LENGTH = 950; // byte offset
const int MOD_HEADER = 1080; // M.K.
const int MOD_PATTERN_START = 1084; 
